EclaireXL - Bug #75

USB keyboard stops functioning after idle period
10/01/2018 10:16 PM - Farb
Description

| have noticed in the last few core builds (up to and including v29) that if the USB keyboard is idle for too long, it stops working.
Sometimes unplugging/replugging the USB connector fixes the problem and sometimes it doesn't.

History

#1 - 10/02/2018 10:27 AM - foft

Two potential problems:
1) max number of devices was decreased in v28, should have no impact but it was a change.
2) SIO can block usb polling and there have been significant sio changes.

This really seems to be elapsed time? Did you check another keyboard? Any particular software running?

#2 - 10/02/2018 02:41 PM - Farb
| have seen it happen a few times using the same USB keyboard (which was also the same keyboard | used on the MiST and don't recall having a
problem):

1. Last night using v28 playing a trivia game ("Millionaire" from the 2018 ABBUC software contest). We contemplated an answer a bit too long and the
keyboard would no longer work. | unplugged/plugged it back in but it did not recover. No disk activity (or any other activity) occurred in the time
between it working and not. Was forced to reboot the EclaireXL and the keyboard started working again. The game's ATR file was loaded from the
built-in disk emulation and wasn't using any external device. Two joysticks were plugged in but not being used.

2. It happened a number of times several weeks ago while working on Sdrive Max ATX code (don't know which core version but it was a few back --
maybe v25 or v26). | was running Diskey to load individual disk sectors and let things sit idle to the point that the attract mode color cycling had been
running a while. When | resumed trying to load sectors, the keyboard wouldn't respond. | distinctly remember unplugging/plugging the USB connector
and recovering at least once but can't say with certainty that it fixed it consistently. One joystick was likely plugged in at that time.

Could a problematic ribbon cable between the main and daughter boards be a possible cause? Could be irrelevant but | haven't replaced a faulty
ribbon cable that caused joystick problems. | merely swapped the two cables and joysticks started working properly.

#3 - 10/02/2018 07:25 PM - foft

Unlikely to be the ribbon, though if its iffy you should replace it. | say that because while the joysticks are connected via the ribbon, the usb ports are
directly connected to the fpga.

Might be worth trying a different keyboard to see if it still happens.
Do you know if the core is still running? i.e. do the joysticks still work + the screen is still update + music playing?

#4 - 10/02/2018 08:39 PM - sadosp

Farb wrote:
Could be irrelevant but | haven't replaced a faulty ribbon cable that caused joystick problems. | merely swapped the two cables and joysticks started
working properly.

Irrespective of the problem with the keyboard,l am very surprised, why you haven't change the ribbon cables till now with the new ones | sent you!
#5 - 10/02/2018 08:42 PM - sadosp
sadosp wrote:

Farb wrote:

Could be irrelevant but | haven't replaced a faulty ribbon cable that caused joystick problems. | merely swapped the two cables and joysticks

started working properly.

Irrespective of the problem with the keyboard, | am very surprised, why you haven't change the ribbon cables till now with the new ones | sent
you!
#6 - 10/03/2018 10:47 AM - Farb

Yes, the core is still running because we were hearing music play. The game we were playing didn't use a joystick so we couldn't test that. | can try to
reproduce with something that uses both joystick and keyboard. | will also see if | can reproduce with my other USB keyboard.

@sadosp: | know, | was being distracted with other things and kept putting it off. The new cables are sitting right here waiting to be replaced. | will do
that today :-P

#7 - 10/04/2018 07:03 AM - foft

Well | just received Millionaire on disk so | can give it a go and see if | have the same issue. My keyboard definitely keeps working when idle in basic
since | leave it there all the time while debugging the core:-)

#8 - 10/05/2018 09:33 PM - foft

How is it going with the other keyboard?

#9 - 10/05/2018 09:36 PM - Farb

Frustratingly, | have not been easily able to reproduce the effect with the keyboard it occurred on before. | will spend some more time attempting to
reproduce soon but will be traveling for the next week or so.

#10 - 10/31/2019 09:21 PM - foft

Jurgen has this with both his keyboards after about 20 minutes.

| also thought | saw it when running the Eclaire for a prolonged period at a show earlier this year.

Anyway did some investigation...

| left my keyboard for an hour and it froze. | think its only when its idle, so pressing a key makes it take longer.

#11 - 10/31/2019 09:23 PM - foft

So, decided to take it seriously.

My picoscope claimes to decode USB, tried that and found it pretty poor.

So | tried to capture the full data stream to PC and decode it with sigrok. | got some valid packets once or twice, but it seems unreliable, | think on the
capture side. These data rates are pushing streaming on the picoscope.

#12 - 10/31/2019 09:24 PM - foft

Tempted to get a Saleae logic USB3 analyzer to capture at a higher rate and they also have USB decoding. Its several hundred though, so not sure.
Clearly its worth it if I'd use it a log but not sure | will. They very kindly have electronics enthusiast pricing (not commercial) which makes it more likely.

#13 - 10/31/2019 09:25 PM - foft

While | mull that | tried building a core that can enter the menu with fire. So | can see if it is indeed USB that crashes and not the whole ZPU.

#14 - 10/31/2019 10:22 PM - foft

| left it for an hour, then typed and it worked... sigh.

#15 - 10/31/2019 10:36 PM - foft

OK, finally froze. | could still enter the menu with fire and it worked. So ZPU is alive, just USB is dead.
Ordered the Saleae analyzer to see if the USB debugging is any good too:-)

#16 - 10/31/2019 10:47 PM - foft

- Status changed from New to In Progress

#17 - 11/01/2019 09:30 PM - foft

Trying it with two keyboards. So far an hour and working.
Though | have a hunch that it'll stop working in 10 minutes!!
The code does this:

if(timer_get_msec() > host->poll) {

host->poll = timer_get_msec()+1;

| reckon it overflows after about 70 minutes.

#18 - 11/01/2019 09:32 PM - foft
((2"32)/1€6)/60 = 71...

So trivial fix. | clearly don't need the Saleae to debug this one, but that isn't so bad. | can use it for the real-time bus capture to debug the whole
system and also for the usb hub debugging.

#19 - 11/01/2019 10:17 PM - foft

- Status changed from In Progress to Resolved

Added a timer elapsed function that handles the overflow. This makes the max delay 35 mins, but | think that is ok... This is usually used for ms or us
delays.

#20 - 11/01/2019 10:17 PM - foft

- Status changed from Resolved to Closed
